#ifndef BLAST_GRAPHIC_SPRITEBATCH_H
#define BLAST_GRAPHIC_SPRITEBATCH_H

#include <list>
#include "Blast/Design/Singleton.h"
#include "Blast/Graphic/SpriteImage.h"
#include "Blast/Graphic/ICamera.h"
#include "Blast/Graphic/DirectX9/MeshSpriteDX9.h"
#include "Blast/Graphic/DirectX9/ShaderEffectDX9.h"


namespace Blast
{
	namespace Graphic
	{
		/// XvCg`s
		class SpriteBatch : public Blast::Design::Singleton<SpriteBatch>
		{
			//====================================================================================================
			// Operation
			//----------------------------------------------------------------------------------------------------

		public:
			/// RXgN^
			SpriteBatch();
			/// fXgN^
			~SpriteBatch();

			/// ob`Jn
			void Begin();
			/// ob`IBɎۂ̕`揈sB
			/// `\񂵂̂̓NÂŁA`\͖t[sKvB
			void End();

			/// 摜`
			void Render(Blast::Graphic::SpriteImage* pImage);


			//====================================================================================================
			// Property
			//----------------------------------------------------------------------------------------------------

			/// J擾
			SP<Blast::Graphic::ICamera> GetCamera();
			/// Jݒ
			void SetCamera(SP<Blast::Graphic::ICamera> value);

			/// Beginς݂ǂ擾
			bool IsHasBegun() const;


			//====================================================================================================
			// Field
			//----------------------------------------------------------------------------------------------------

		private:
			SP<Blast::Graphic::ICamera>			mPCamera;	///< J
			SP<Blast::Graphic::MeshSpriteDX9>	mPMesh;		///< bV
			SP<Blast::Graphic::ShaderEffectDX9>	mPShader;	///< VF[_[

			bool		mIsHasBegun;	///< Beginς݂ǂ̃tO
			unsigned	mPassCount;		///< VF[_[̃pX

			
			//====================================================================================================
			// Implement
			//----------------------------------------------------------------------------------------------------

		private:

		};
	} // namespace Graphic
} // namespace Blast

#endif // BLAST_GRAPHIC_SPRITEBATCH_H